diff -uNr fwbuilder-2.1.8/src/gui/FWWindow.h fwbuilder-2.1.9/src/gui/FWWindow.h
--- fwbuilder-2.1.8/src/gui/FWWindow.h	2006-09-11 02:41:09.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/FWWindow.h	2007-02-04 04:58:59.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: FWWindow.h,v 1.77 2006/09/11 00:41:09 vkurland Exp $
+  $Id: FWWindow.h,v 1.79 2007/02/04 03:58:59 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -111,6 +111,7 @@
      virtual void fileExit();
      virtual void fileProp();
      virtual void fileAddToRCS();
+     virtual void fileCompare();
      virtual void editCopy();
      virtual void editCut();
      virtual void editDelete();
@@ -216,9 +217,9 @@
     RuleSetView* getRuleSetViews(libfwbuilder::FWObject *o) 
     {return ruleSetViews[o];};
 
-    void addPolicyBranchTab(libfwbuilder::PolicyRule *rule);
-    void removePolicyBranchTab(libfwbuilder::PolicyRule *rule);
-    void setPolicyBranchTabName(libfwbuilder::PolicyRule *rule);
+    void addPolicyBranchTab(libfwbuilder::RuleSet *subset);
+    void removePolicyBranchTab(libfwbuilder::RuleSet *subset);
+    void setPolicyBranchTabName(libfwbuilder::RuleSet *subset);
 
     /**
      * panel that wants to open an object in the editor
@@ -243,6 +244,17 @@
 
     void scheduleRuleSetRedraw();
 
+    // semi-intelligent way to guess most appropriate
+    // destination directory for various file save or file open
+    // operations. If working directory is configured in
+    // preferences, then getDestDir returns that. If it is not
+    // configured and file name is given on the command line,
+    // directory where that file is located is returned. If
+    // parameter filename is empty, then current directory
+    // is returned (however on windows and mac userDataDir is returned)
+
+    QString getDestDir(const QString &filename);
+
  protected:
 
     virtual void showEvent( QShowEvent *ev);
diff -uNr fwbuilder-2.1.8/src/gui/GroupObjectDialog.cpp fwbuilder-2.1.9/src/gui/GroupObjectDialog.cpp
--- fwbuilder-2.1.8/src/gui/GroupObjectDialog.cpp	2006-10-22 06:39:36.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/GroupObjectDialog.cpp	2007-01-08 04:24:48.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: GroupObjectDialog.cpp,v 1.54 2006/10/22 04:39:36 vkurland Exp $
+  $Id: GroupObjectDialog.cpp,v 1.57 2007/01/08 03:24:48 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -39,6 +39,7 @@
 #include "ObjectManipulator.h"
 #include "FWObjectDrag.h"
 #include "FWObjectClipboard.h"
+#include "ObjectTreeView.h"
 
 #include "fwbuilder/Library.h"
 #include "fwbuilder/Group.h"
@@ -624,13 +625,24 @@
 
 void GroupObjectDialog::dropped(QDropEvent *ev)
 {
+    if (fwbdebug) qDebug("GroupObjectDialog::dropped");
+
     list<FWObject*> ol;
     if (FWObjectDrag::decode(ev, ol))
     {
         if (ol.size()==0) return;
         for (list<FWObject*>::iterator i=ol.begin(); i!=ol.end(); ++i)
             insertObject( *i );
+        if (fwbdebug) qDebug("GroupObjectDialog::dropped  ev->acceptAction()");
+        ev->acceptAction();
+
+        // see comment in ObjectTreeView.cpp explaining the purpose of
+        // flag process_mouse_release_event
+        ObjectTreeView *otv = om->getCurrentObjectTree();
+        otv->ignoreNextMouseReleaseEvent();
+
     }
+    if (fwbdebug) qDebug("GroupObjectDialog::dropped  done");
 }
 
 void GroupObjectDialog::iconContextMenu(QIconViewItem *itm,const QPoint &p)
diff -uNr fwbuilder-2.1.8/src/gui/instBatchOptionsDialog.cpp fwbuilder-2.1.9/src/gui/instBatchOptionsDialog.cpp
--- fwbuilder-2.1.8/src/gui/instBatchOptionsDialog.cpp	2006-08-28 08:03:10.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/instBatchOptionsDialog.cpp	2007-01-06 09:24:57.000000000 +0100
@@ -2,11 +2,11 @@
 
                           Firewall Builder
 
-                 Copyright (C) 2003 NetCitadel, LLC
+                 Copyright (C) 2006 NetCitadel, LLC
 
   Author:  Illiya Yalovoy <yalovoy@gmail.com>
 
-  $Id: instBatchOptionsDialog.cpp,v 1.3 2006/08/28 06:03:10 vkurland Exp $
+  $Id: instBatchOptionsDialog.cpp,v 1.4 2007/01/06 08:24:57 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -31,10 +31,6 @@
 
 #include "instBatchOptionsDialog.h"
 
-#include "fwbuilder/Library.h"
-#include "fwbuilder/FWException.h"
-#include "fwbuilder/Firewall.h"
-
 #include <qstring.h>
 #include <qlineedit.h>
 #include <qlabel.h>
@@ -44,7 +40,7 @@
 using namespace std;
 using namespace libfwbuilder;
 
-instBatchOptionsDialog::instBatchOptionsDialog(QWidget *parent) : instOptionsDialog_q(parent)
+instBatchOptionsDialog::instBatchOptionsDialog(QWidget *parent) : instOptionsDialog(parent)
 {
     dialogTitleLine->setText(QString("<p align=\"center\"><b><font size=\"+2\">")+
                              tr("Batch install options")+
@@ -55,24 +51,3 @@
     
 }
 
-void instBatchOptionsDialog::applyChanges()
-{
-    hide();
-}
-
-void instBatchOptionsDialog::discardChanges()
-{
-    hide();
-}
-
-QString instBatchOptionsDialog::getUName() { return uname->text(); }
-QString instBatchOptionsDialog::getPWD()   { return pwd->text();   }
-QString instBatchOptionsDialog::getEPWD()  { return epwd->text();  }
-
-void instBatchOptionsDialog::closeEvent(QCloseEvent *e)
-{
-    if (fwbdebug)
-        qDebug("instBatchOptionsDialog::closeEvent  got close event: %p",e);
-    hide();
-}
-
diff -uNr fwbuilder-2.1.8/src/gui/instBatchOptionsDialog.h fwbuilder-2.1.9/src/gui/instBatchOptionsDialog.h
--- fwbuilder-2.1.8/src/gui/instBatchOptionsDialog.h	2006-04-13 18:18:52.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/instBatchOptionsDialog.h	2007-01-06 09:24:57.000000000 +0100
@@ -2,11 +2,11 @@
 
                           Firewall Builder
 
-                 Copyright (C) 2003 NetCitadel, LLC
+                 Copyright (C) 2006 NetCitadel, LLC
 
   Author:  Illiya Yalovoy <yalovoy@gmail.com>
 
-  $Id: instBatchOptionsDialog.h,v 1.1 2006/04/13 16:18:52 vkurland Exp $
+  $Id: instBatchOptionsDialog.h,v 1.2 2007/01/06 08:24:57 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -28,37 +28,16 @@
 #define __INSTBATCHOPTIONSDIALOG_H_
 
 #include "config.h"
-#include <instoptionsdialog_q.h>
+#include <instOptionsDialog.h>
 
-#include "fwbuilder/FWObject.h"
-#include "fwbuilder/Resources.h"
-
-
-
-class instBatchOptionsDialog : public instOptionsDialog_q
+class instBatchOptionsDialog : public instOptionsDialog
 {
     Q_OBJECT
  private:
  
  public:
     instBatchOptionsDialog(QWidget *parent);
-    virtual void closeEvent(QCloseEvent *e);
-    QString getUName();
-    QString getPWD();
-    QString getEPWD();
 
-
-public slots:
-    virtual void applyChanges();
-    virtual void discardChanges();
-    
- signals:
-/**
- * This signal is emitted from closeEvent, ObjectEditor connects
- * to this signal to make checks before the object editor can be closed
- * and to store its position on the screen
- */
-   // void close_sign(QCloseEvent *e);
     
 };
 
diff -uNr fwbuilder-2.1.8/src/gui/instDialog.cpp fwbuilder-2.1.9/src/gui/instDialog.cpp
--- fwbuilder-2.1.8/src/gui/instDialog.cpp	2006-10-21 08:19:36.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/instDialog.cpp	2007-01-30 17:48:10.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: instDialog.cpp,v 1.95 2006/10/21 06:19:36 vkurland Exp $
+  $Id: instDialog.cpp,v 1.99 2007/01/30 16:48:10 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -49,6 +49,7 @@
 #include <qapplication.h>
 #include <qeventloop.h>
 #include <qfile.h>
+#include <qdir.h>
 #include <qmessagebox.h>
 #include <qspinbox.h>
 #include <qgroupbox.h>
@@ -224,86 +225,68 @@
 
     QString platform=cnf.fwobj->getStr("platform").c_str();
 
+    dlg->uname->setFocus();
+    dlg->uname->setText( cnf.user );
+    dlg->incr->setChecked( cnf.incremental );
+    dlg->test->setChecked( cnf.dry_run );
+    dlg->backupConfigFile->setText( cnf.backup_file );
+    dlg->saveDiff->setChecked( cnf.save_diff );
+    dlg->saveStandby->setChecked( cnf.saveStandby );
+    dlg->altAddress->setText( cnf.maddr );
+    dlg->quiet->setChecked( cnf.quiet );
+    dlg->verbose->setChecked( cnf.verbose );
+    dlg->stripComments->setChecked( cnf.stripComments );
+    dlg->compressScript->setChecked( cnf.compressScript );
+    dlg->copyFWB->setChecked( cnf.copyFWB );
+    dlg->testRun->setChecked( cnf.testRun );
+    dlg->rollback->setChecked( cnf.rollback );
+    dlg->rollbackTime->setValue( cnf.rollbackTime );
+
+    bool f = dlg->testRun->isChecked();
+    if (cnf.fwobj->getStr("host_OS")=="pix_os" || cnf.fwobj->getStr("host_OS")=="fwsm_os")
+    {
+        dlg->rollback->setChecked( false );
+        f=false;
+    }
+
+    dlg->rollback->setEnabled(f);
+    dlg->rollbackTime->setEnabled(f);
+    dlg->rollbackTimeUnit->setEnabled(f);
+    
+    QSize pix_options_frame_size = dlg->PIXgroupBox->sizeHint();
+
     cnf.rollbackTimeUnit=
         Resources::getTargetOptionStr(cnf.fwobj->getStr("host_OS"),
                                       "activation/timeout_units").c_str();
     if ((platform!="pix" && platform!="fwsm" && !batchInstall->isChecked()) ||
         (!fPix && batchInstall->isChecked()) )
     {
-        dlg->incr->hide();
-        dlg->test->hide();
-        dlg->saveDiff->hide();
-        dlg->saveStandby->hide();
-        dlg->backupConfigFile->hide();
-        dlg->backupConfigFileLbl->hide();
-        dlg->epwd->hide();
-        dlg->epwdLbl->hide();
-
-        dlg->PIXgroupBox->hide();
-    } else
-    {
-// if PIX or FWSM:
-        dlg->copyFWB->hide();
-
-        dlg->incr->show();
-        dlg->test->show();
-        dlg->saveDiff->show();
-        dlg->saveStandby->show();
-        dlg->backupConfigFile->show();
-        dlg->backupConfigFileLbl->show();
-        dlg->epwd->show();
-        dlg->epwdLbl->show();
-
-        dlg->PIXgroupBox->show();
+        dlg->hidePIXOptions();
     }
 
 /* hide anyway, diff does not work for pix 6.3(3) */
+    //dlg->hideOption( dlg->saveDiff );
     dlg->saveDiff->hide();
 
     //progressBar->hide();
-    dlg->stripComments->hide();
-    dlg->compressScript->hide();
-
-   //if (platform=="pix" || platform=="fwsm")
-   //{
-   //    progressBar->show();
-   //    stripComments->show();
-   //}
-
-    if (cnf.fwobj->getStr("host_OS")=="linksys")
-    {
-        dlg->compressScript->show();
-    }
+    //dlg->hideOption( dlg->stripComments );
+    dlg->stripComments->hide(); 
+    //dlg->compressScript->hide();
 
+    //if (platform=="pix" || platform=="fwsm")
+    //{
+    //    progressBar->show();
+    //    stripComments->show();
+    //}
 
-   dlg->uname->setFocus();
-   dlg->uname->setText( cnf.user );
-   dlg->incr->setChecked( cnf.incremental );
-   dlg->test->setChecked( cnf.dry_run );
-   dlg->backupConfigFile->setText( cnf.backup_file );
-   dlg->saveDiff->setChecked( cnf.save_diff );
-   dlg->saveStandby->setChecked( cnf.saveStandby );
-   dlg->altAddress->setText( cnf.maddr );
-   dlg->quiet->setChecked( cnf.quiet );
-   dlg->verbose->setChecked( cnf.verbose );
-   dlg->stripComments->setChecked( cnf.stripComments );
-   dlg->compressScript->setChecked( cnf.compressScript );
-   dlg->copyFWB->setChecked( cnf.copyFWB );
-   dlg->testRun->setChecked( cnf.testRun );
-   dlg->rollback->setChecked( cnf.rollback );
-   dlg->rollbackTime->setValue( cnf.rollbackTime );
-
-    bool f = dlg->testRun->isChecked();
-    if (cnf.fwobj->getStr("host_OS")=="pix_os" || cnf.fwobj->getStr("host_OS")=="fwsm_os")
+    if (cnf.fwobj->getStr("host_OS")!="linksys")
     {
-        dlg->rollback->setChecked( false );
-        f=false;
+        dlg->compressScript->hide();
+        //dlg->hideOption( dlg->compressScript );
     }
 
-    dlg->rollback->setEnabled(f);
-    dlg->rollbackTime->setEnabled(f);
-    dlg->rollbackTimeUnit->setEnabled(f);
-    
+    //dlg->adjustSize();
+    //dlg->setFixedHeight( dlg->minimumSizeHint().height() );
 
 /* we initialize these in FWBSettings constructor on Unix, but do not
  * do it on Windows since there is no standard ssh package there. User
@@ -639,6 +622,11 @@
     lastPage=indexOf( currentPage() );
 }
 
+QString instDialog::getFullPath(instConf &cnf, const QString &file )
+{
+    if (QDir::isRelativePath(file)) return cnf.wdir + "/" + file;
+    else return file;
+}
 
 bool instDialog::doInstallPage()
 {
@@ -724,7 +712,8 @@
         }
 /* read manifest from the conf file */
 
-        QFile cf(  cnf.wdir+"/"+cnf.conffile );
+        QString conffile_path = getFullPath(cnf,cnf.conffile);
+        QFile cf( conffile_path  );
         if (cf.open( IO_ReadOnly ) )
         {
             QTextStream stream(&cf);
@@ -753,7 +742,7 @@
         } else
         {
             QMessageBox::critical(this, "Firewall Builder",
-                 tr("File %1 not found.").arg(cnf.wdir+"/"+cnf.conffile),
+                 tr("File %1 not found.").arg(conffile_path),
                                   tr("&Continue") );
             return false;
         }
@@ -904,8 +893,20 @@
 /* replace macros in activation command:
  *
  * %FWSCRIPT%, %FWDIR%, %FWBPROMPT%, %RBTIMEOUT%
+ *
+ * check if cnf.conffile is a full path. If it is, strip the path part
+ * and use only the file name for %FWSCRIPT%
  */
-    cmd.replace("%FWSCRIPT%",cnf.conffile);
+    QString clean_conffile = cnf.conffile.section(QDir::separator(),-1);
+    if (fwbdebug)
+    {
+        qDebug("Macro substitutions:");
+        qDebug(QString("  cnf.conffile=%1").arg(cnf.conffile));
+        qDebug(QString("  %%FWSCRIPT%%=%1").arg(clean_conffile));
+        qDebug(QString("  %%FWDIR%%=%1").arg(cnf.fwdir));
+    }
+
+    cmd.replace("%FWSCRIPT%",clean_conffile);
     cmd.replace("%FWDIR%",cnf.fwdir);
     cmd.replace("%FWBPROMPT%",fwb_prompt);
 
@@ -934,16 +935,16 @@
     
     std::ifstream   *wfile;
 
-    QString ff = cnf.wdir+"/"+file;
+    QString file_with_path = getFullPath(cnf,file);
 
-    wfile = new ifstream(ff.latin1());
+    wfile = new ifstream(file_with_path.latin1());
     if ( ! *wfile)
     {
-        ff = file;  // .fwb file path already includes wdir
-        wfile = new ifstream(ff.latin1());
+        file_with_path = file;  // .fwb file path already includes wdir
+        wfile = new ifstream(file_with_path.latin1());
         if ( ! *wfile)
         {
-            addToLog(QObject::tr("Can not open file %1").arg(ff));
+            addToLog(QObject::tr("Can not open file %1").arg(file_with_path));
             delete wfile;
             return;
         }
@@ -1018,16 +1019,28 @@
 /* replace macros in activation command:
  *
  * %FWSCRIPT%, %FWDIR%, %FWBPROMPT%, %RBTIMEOUT%
+ *
+ * check if cnf.conffile is a full path. If it is, strip the path part
+ * and use only the file name for %FWSCRIPT%
  */
+    QString clean_conffile = cnf.conffile.section(QDir::separator(),-1);
+    if (fwbdebug)
+    {
+        qDebug("Macro substitutions:");
+        qDebug(QString("  cnf.conffile=%1").arg(cnf.conffile));
+        qDebug(QString("  %%FWSCRIPT%%=%1").arg(clean_conffile));
+        qDebug(QString("  %%FWDIR%%=%1").arg(cnf.fwdir));
+    }
+
     cmd.replace("\n","");
-    cmd.replace("%FWSCRIPT%",file);
+    cmd.replace("%FWSCRIPT%",clean_conffile);
     cmd.replace("%FWDIR%",cnf.fwdir);
     cmd.replace("%FWBPROMPT%",fwb_prompt);
 
     args.push_back(cmd);
         
     addToLog( tr("\nCopying %1 -> %2:%3\n")
-                .arg(cnf.wdir+"/"+file).arg(cnf.maddr).arg(cnf.fwdir) );
+                .arg(file_with_path).arg(cnf.maddr).arg(cnf.fwdir) );
 
     if (cnf.verbose) displayCommand(args);
 
@@ -1393,7 +1406,11 @@
     if (ofname.isEmpty()) ofname = QString(fw->getName().c_str()) + ".fw";
 
     QString fwfname = getFileDir( mw->getRCS()->getFileName() ) + "/" + ofname;
-    if ( !QFile::exists(fwfname) )
+
+/* bug #1617501: "Install fails after compile". Check ofname, just in
+ * case user put full path name for the output script name in options
+ */
+    if ( !QFile::exists(fwfname) && !QFile::exists(ofname))
     {
 /* need to recompile */
         addToLog(tr("Firewall isn't compiled."));
@@ -1401,6 +1418,7 @@
         return false;
     }
     
+
     args.clear();
     
    
diff -uNr fwbuilder-2.1.8/src/gui/instDialog.h fwbuilder-2.1.9/src/gui/instDialog.h
--- fwbuilder-2.1.8/src/gui/instDialog.h	2006-09-16 09:00:53.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/instDialog.h	2007-01-30 17:48:10.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: instDialog.h,v 1.32 2006/09/16 07:00:53 vkurland Exp $
+  $Id: instDialog.h,v 1.34 2007/01/30 16:48:10 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -101,29 +101,29 @@
 
     std::map<libfwbuilder::Firewall *, t_procMess>    processedFirewalls;
 
-    t_fwList    firewalls;
-    t_fwList    opList;
+    t_fwList      firewalls;
+    t_fwList      opList;
 
-    t_fwList::iterator    opListIterator;
+    t_fwList::iterator   opListIterator;
 
-    t_listMap opListMapping;
-    t_tableMap compileMapping;
-    t_tableMap installMapping;
+    t_listMap            opListMapping;
+    t_tableMap           compileMapping;
+    t_tableMap           installMapping;
     
-    QStringList args;
+    QStringList          args;
         
-    QTextEdit    *currentLog;
-    QButton      *currentSaveButton;
-    QButton      *currentStopButton;
-    QProgressBar *currentProgressBar;
-    QProgressBar *currentFirewallsBar;
-    QLabel       *currentLabel;
-    QLabel       *currentFWLabel;
-    QString     currentSearchString;
+    QTextEdit           *currentLog;
+    QButton             *currentSaveButton;
+    QButton             *currentStopButton;
+    QProgressBar        *currentProgressBar;
+    QProgressBar        *currentFirewallsBar;
+    QLabel              *currentLabel;
+    QLabel              *currentFWLabel;
+    QString              currentSearchString;
     
-    BatchOperation operation;
+    BatchOperation       operation;
     instOptionsDialog_q *dlg;
-    QString        pendingLogLine;
+    QString              pendingLogLine;
 
     int progress;
     int totalRules;
@@ -182,6 +182,9 @@
     virtual void prepareInstConf(libfwbuilder::Firewall *fw);
     virtual void storeInstallerOptions();
     virtual void findFirewalls();
+
+    QString getFullPath(instConf &cnf, const QString &file );
+
  protected slots:
      void processExited();
      void installerFinished();
diff -uNr fwbuilder-2.1.8/src/gui/instOptionsDialog.cpp fwbuilder-2.1.9/src/gui/instOptionsDialog.cpp
--- fwbuilder-2.1.8/src/gui/instOptionsDialog.cpp	2006-04-13 18:18:52.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/instOptionsDialog.cpp	2007-01-06 09:24:57.000000000 +0100
@@ -2,11 +2,11 @@
 
                           Firewall Builder
 
-                 Copyright (C) 2003 NetCitadel, LLC
+                 Copyright (C) 2006 NetCitadel, LLC
 
   Author:  Illiya Yalovoy <yalovoy@gmail.com>
 
-  $Id: instOptionsDialog.cpp,v 1.1 2006/04/13 16:18:52 vkurland Exp $
+  $Id: instOptionsDialog.cpp,v 1.2 2007/01/06 08:24:57 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -31,12 +31,12 @@
 
 #include "instOptionsDialog.h"
 
-#include "fwbuilder/Library.h"
-#include "fwbuilder/FWException.h"
-#include "fwbuilder/Firewall.h"
-
 #include <qstring.h>
 #include <qlineedit.h>
+#include <qcheckbox.h>
+#include <qgroupbox.h>
+#include <qlabel.h>
+#include <qlayout.h>
 
 #include <stdlib.h>
 
@@ -44,6 +44,12 @@
 using namespace libfwbuilder;
 
     
+instOptionsDialog::instOptionsDialog(QWidget *parent) : instOptionsDialog_q(parent)
+{
+    delta_y = 0;
+    setSizeGripEnabled(false);
+    resize( 600, 600 );
+}
 
 void instOptionsDialog::applyChanges()
 {
@@ -59,6 +65,29 @@
 QString instOptionsDialog::getPWD()   { return pwd->text();   }
 QString instOptionsDialog::getEPWD()  { return epwd->text();  }
 
+void instOptionsDialog::hidePIXOptions()
+{
+    QLayout *l = layout();
+    int m = l->spacing();
+
+    delta_y += incr->height() + m;                  incr->hide();
+    delta_y += test->height() + m;                  test->hide();
+    //delta_y += saveDiff->height() + m;              saveDiff->hide();
+    delta_y += saveStandby->height() + m;           saveStandby->hide();
+    delta_y += backupConfigFile->height() + m;      backupConfigFile->hide();
+    delta_y += backupConfigFileLbl->height() + m;   backupConfigFileLbl->hide();
+    delta_y += epwd->height() + m;                  epwd->hide();
+    delta_y += epwdLbl->height() + m;               epwdLbl->hide();
+
+    PIXgroupBox->hide();
+}
+
+void instOptionsDialog::hideOption(QWidget *w)
+{
+    delta_y += w->height();
+    w->hide();
+}
+
 void instOptionsDialog::closeEvent(QCloseEvent *e)
 {
     if (fwbdebug)
@@ -66,3 +95,27 @@
     hide();
 }
 
+QSize instOptionsDialog::sizeHint() const
+{
+    QSize sh = QDialog::sizeHint();
+    sh.setHeight( sh.height() - ((delta_y)?(delta_y+20):0) );
+    if (fwbdebug)
+    {
+        qDebug(QString("instOptionsDialog::sizeHint:  w=%1 h=%2").arg(sh.width()).arg(sh.height()));
+        qDebug(QString("delta_y=%1").arg(delta_y));
+    }
+    return sh;
+}
+
+QSize instOptionsDialog::minimumSizeHint() const
+{
+    QSize sh = QDialog::minimumSizeHint();
+    sh.setHeight( sh.height() - ((delta_y)?(delta_y+20):0) );
+    if (fwbdebug)
+    {
+        qDebug(QString("instOptionsDialog::minimumSizeHint:  w=%1 h=%2").arg(sh.width()).arg(sh.height()));
+        qDebug(QString("delta_y=%1").arg(delta_y));
+    }
+    return sh;
+}
+
diff -uNr fwbuilder-2.1.8/src/gui/instOptionsDialog.h fwbuilder-2.1.9/src/gui/instOptionsDialog.h
--- fwbuilder-2.1.8/src/gui/instOptionsDialog.h	2006-04-13 18:18:52.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/instOptionsDialog.h	2007-01-06 09:24:57.000000000 +0100
@@ -2,11 +2,11 @@
 
                           Firewall Builder
 
-                 Copyright (C) 2003 NetCitadel, LLC
+                 Copyright (C) 2006 NetCitadel, LLC
 
   Author:  Illiya Yalovoy <yalovoy@gmail.com>
 
-  $Id: instOptionsDialog.h,v 1.1 2006/04/13 16:18:52 vkurland Exp $
+  $Id: instOptionsDialog.h,v 1.2 2007/01/06 08:24:57 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -30,23 +30,25 @@
 #include "config.h"
 #include <instoptionsdialog_q.h>
 
-#include "fwbuilder/FWObject.h"
-#include "fwbuilder/Resources.h"
-
-
-
 class instOptionsDialog : public instOptionsDialog_q
 {
     Q_OBJECT
  private:
- 
+    int delta_y;
+
  public:
-    instOptionsDialog(QWidget *parent) : instOptionsDialog_q(parent){};
+    instOptionsDialog(QWidget *parent);
     virtual void closeEvent(QCloseEvent *e);
+
     QString getUName();
     QString getPWD();
     QString getEPWD();
 
+    virtual QSize sizeHint() const;
+    virtual QSize minimumSizeHint() const;
+
+    virtual void hidePIXOptions();
+    virtual void hideOption(QWidget *w);
 
 public slots:
     virtual void applyChanges();
